/// <reference types="node" />
import { Closeable, Deferred, Demultiplexer, DuplexConnection, Frame, FrameHandler, Multiplexer, Outbound } from "rsocket-core";
import net from "net";
export declare class TcpDuplexConnection extends Deferred implements DuplexConnection, Outbound {
    private socket;
    private error;
    private remainingBuffer;
    readonly multiplexerDemultiplexer: Multiplexer & Demultiplexer & FrameHandler;
    constructor(socket: net.Socket, frame: Frame, multiplexerDemultiplexerFactory: (frame: Frame, outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler);
    get availability(): number;
    close(error?: Error): void;
    send(frame: Frame): void;
    private handleClosed;
    private handleError;
    private handleData;
    static create(socket: net.Socket, connectionAcceptor: (frame: Frame, connection: DuplexConnection) => Promise<void>, multiplexerDemultiplexerFactory: (frame: Frame, outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler): void;
}
