/// <reference types="node" />
import { Closeable, Demultiplexer, DuplexConnection, Frame, FrameHandler, Multiplexer, Outbound, ServerTransport } from "rsocket-core";
import net from "net";
declare type TcpServerOptionsSocketFactory = (options: net.ServerOpts) => net.Server;
declare type TcpServerOptions = {
    serverOptions?: net.ServerOpts;
    listenOptions: net.ListenOptions;
    socketCreator?: TcpServerOptionsSocketFactory;
};
export declare class TcpServerTransport implements ServerTransport {
    private readonly serverOptions;
    private readonly listenOptions;
    private readonly serverCreator;
    constructor(options: TcpServerOptions);
    bind(connectionAcceptor: (frame: Frame, connection: DuplexConnection) => Promise<void>, multiplexerDemultiplexerFactory: (frame: Frame, outbound: Outbound & Closeable) => Multiplexer & Demultiplexer & FrameHandler): Promise<Closeable>;
}
export {};
